
.. DO NOT EDIT.
.. THIS FILE WAS AUTOMATICALLY GENERATED BY SPHINX-GALLERY.
.. TO MAKE CHANGES, EDIT THE SOURCE PYTHON FILE:
.. "gettingstarted/gallery/auto_examples/analysis/plot_pca_iris.py"
.. LINE NUMBERS ARE GIVEN BELOW.

.. only:: html

    .. note::
        :class: sphx-glr-download-link-note

        :ref:`Go to the end <sphx_glr_download_gettingstarted_gallery_auto_examples_analysis_plot_pca_iris.py>`
        to download the full example code

.. rst-class:: sphx-glr-example-title

.. _sphx_glr_gettingstarted_gallery_auto_examples_analysis_plot_pca_iris.py:


PCA analysis example
---------------------
In this example, we perform the PCA dimensionality reduction of the classical ``iris`` dataset (Ronald A. Fisher.
"The Use of Multiple Measurements in Taxonomic Problems. Annals of Eugenics, 7, pp.179-188, 1936).

.. GENERATED FROM PYTHON SOURCE LINES 16-17

First we laod the spectrochempy API package

.. GENERATED FROM PYTHON SOURCE LINES 17-19

.. code-block:: default

    import spectrochempy as scp








.. GENERATED FROM PYTHON SOURCE LINES 20-21

Upload a dataset form a distant server

.. GENERATED FROM PYTHON SOURCE LINES 21-29

.. code-block:: default

    try:
        dataset = scp.download_iris()
    except (IOError, OSError):
        print("Could not load The `IRIS` dataset. Finishing here.")
        import sys

        sys.exit(0)








.. GENERATED FROM PYTHON SOURCE LINES 30-31

Create a PCA object

.. GENERATED FROM PYTHON SOURCE LINES 31-33

.. code-block:: default

    pca = scp.PCA(dataset, centered=True)








.. GENERATED FROM PYTHON SOURCE LINES 34-37

Reduce the data to a lower dimensionality. Here, the number of
components is automatically determined using `n_pc="auto"`. As
indicated by the dimension of LT, 4 PC are found.

.. GENERATED FROM PYTHON SOURCE LINES 37-42

.. code-block:: default


    S, LT = pca.reduce(n_pc="auto")

    print(LT)





.. rst-class:: sphx-glr-script-out

 .. code-block:: none

    NDDataset: [float64] cm (shape: (y:3, x:4))




.. GENERATED FROM PYTHON SOURCE LINES 43-46

The figures of merit (explained and cumulative variance) confirm that
these 4 PC's explain 100% of the variance:


.. GENERATED FROM PYTHON SOURCE LINES 46-48

.. code-block:: default

    pca.printev()





.. rst-class:: sphx-glr-script-out

 .. code-block:: none


    PC      Eigenvalue              %variance               %cumulative
             of cov(X)                 per PC                  variance
    #1       1.449e+01                 92.462                    92.462
    #2       3.469e+00                  5.302                    97.763
    #3       1.975e+00                  1.719                    99.482
    #4       1.085e+00                  0.518                   100.000





.. GENERATED FROM PYTHON SOURCE LINES 49-52

These figures of merit can also be displayed graphically

The ScreePlot

.. GENERATED FROM PYTHON SOURCE LINES 52-54

.. code-block:: default

    _ = pca.screeplot()




.. rst-class:: sphx-glr-horizontal


    *

      .. image-sg:: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_001.png
         :alt: Scree plot
         :srcset: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_001.png
         :class: sphx-glr-multi-img

    *

      .. image-sg:: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_002.png
         :alt: plot pca iris
         :srcset: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_002.png
         :class: sphx-glr-multi-img





.. GENERATED FROM PYTHON SOURCE LINES 55-58

The score plots can be used for classification purposes. The first one - in 2D for the 2 first PC's - shows that the first PC
allows distinguishing Iris-setosa (score of PC#1 < -1) from other species (score of PC#1 > -1), while more PC's are required
to distinguish versicolor from viginica.

.. GENERATED FROM PYTHON SOURCE LINES 58-60

.. code-block:: default

    _ = pca.scoreplot(1, 2, color_mapping="labels")




.. image-sg:: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_003.png
   :alt: Score plot
   :srcset: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_003.png
   :class: sphx-glr-single-img





.. GENERATED FROM PYTHON SOURCE LINES 61-63

The second one - in 3D for the 3 first PC's - indicates that a thid PC won't allow better distinguishing versicolor
from viginica.

.. GENERATED FROM PYTHON SOURCE LINES 63-67

.. code-block:: default

    ax = pca.scoreplot(1, 2, 3, color_mapping="labels")
    ax.view_init(10, 75)

    # scp.show()  # uncomment to show plot if needed (not necessary in jupyter notebook)



.. image-sg:: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_004.png
   :alt: Score plot
   :srcset: /gettingstarted/gallery/auto_examples/analysis/images/sphx_glr_plot_pca_iris_004.png
   :class: sphx-glr-single-img






.. rst-class:: sphx-glr-timing

   **Total running time of the script:** ( 0 minutes  1.131 seconds)


.. _sphx_glr_download_gettingstarted_gallery_auto_examples_analysis_plot_pca_iris.py:

.. only:: html

  .. container:: sphx-glr-footer sphx-glr-footer-example




    .. container:: sphx-glr-download sphx-glr-download-python

      :download:`Download Python source code: plot_pca_iris.py <plot_pca_iris.py>`

    .. container:: sphx-glr-download sphx-glr-download-jupyter

      :download:`Download Jupyter notebook: plot_pca_iris.ipynb <plot_pca_iris.ipynb>`


.. only:: html

 .. rst-class:: sphx-glr-signature

    `Gallery generated by Sphinx-Gallery <https://sphinx-gallery.github.io>`_
